package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZSample0020;
import cn.ibizlab.core.sample.filter.IBIZSample0020SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZSample0020Mapper extends BaseMapper<IBIZSample0020> {


    Page<IBIZSample0020> searchDefault(IPage page, @Param("ctx") IBIZSample0020SearchContext context, @Param("ew") Wrapper<IBIZSample0020> wrapper);
    List<IBIZSample0020> listDefault(@Param("ctx") IBIZSample0020SearchContext context, @Param("ew") Wrapper<IBIZSample0020> wrapper);

    @Override
    IBIZSample0020 selectById(Serializable id);

    IBIZSample0020 selectEntity(IBIZSample0020 entity);

    List<IBIZSample0020> selectEntities(@Param("list") List<IBIZSample0020> list);

    @Override
    int insert(IBIZSample0020 entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZSample0020 entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZSample0020 entity, @Param("ew") Wrapper<IBIZSample0020> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZSample0020> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZSample0020> selectByIbizsample0019Id(@Param("ibizsample0019Id") Serializable ibizsample0019Id);

}